#!/usr/bin/env python

# pylint: disable=missing-docstring
# pylint: disable=no-name-in-module

import sys

from PyQt5.QtWidgets import (QApplication, QWidget, QListView, QVBoxLayout)
from PyQt5.QtCore import pyqtSignal, pyqtSlot

class Viewer(QListView):

    data = pyqtSignal('PyQt_PyObject')

    def __init__(self, parent=None):
        super(Viewer, self).__init__(parent)

    def sendData(self):
        self.data.emit({1: 2})


class MainWindow(QWidget):

    def __init__(self, parent=None):
        super(MainWindow, self).__init__(parent)
        self.view = Viewer(self)
        layout = QVBoxLayout()
        layout.addWidget(self.view)
        self.setLayout(layout)
        self.resize(600, 800)
        self.view.data.connect(self.showData)
        self.view.sendData()

    def showData(self, data):
        print('data', data, type(data))


def main():
    app = QApplication(sys.argv)
    mainWindow = MainWindow()
    mainWindow.show()
    return app.exec_()


if __name__ == '__main__':
    main()
